;	Function to draw a circle without using trigonometric
;	functions
;
;	r - radius,  n - number of iterations,
;	cx, cy coordinates of center
;
(setq pi 3.14159)
(defun circle (radius n cx cy)
	((lambda (da x y xd yd) ; delta a, x, y, x-dash y-dash
		(do-while (not (zerop n))
			(setq yd (+ (* da x) y))
			(setq xd (- x (* da  yd)))
			(line (+ x cx)(+ y cy)(+ xd cx)(+ yd cy))
			(setq x xd)
			(setq y yd)
			(setq n (- n 1)) ) )
	(/ (* 2.0 pi)(float n))	; da = 2*pi/n
	(* radius 0.707106)(* radius 0.707106) 	; Starting coordinates
	0 0			 ) )

; function to test the above
(defun r ()
	
	((lambda (n)
		(princ (GraphOpen))
		(mode 3)
		(do-while (> n 3)
			(circle 500.0 n 2000 2000)	; draw a circle
			(circle 500 n 2000 2000)	; clear
			(setq n (- n 50)) )
		(GraphClose)
	) 180 ))  ; n = 0
